/* L-Dic(Linux Dictionary)
 * Copyright (C) 2002 Baek SeungSoon.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "readdic.h"
#include "wlist.h"

/* isDic: ldic   ´ ˻
 */
extern int
isDic(FILE *fp)
{
	char buf[5];
	
	fseek(fp, 0, SEEK_SET);

	fread(buf, 4, 1, fp);

	buf[4] = '\0';

	if (strcmp(buf, "LDIC") != '\0') {
		return 0; /* ldic   ƴ. */
	} else {
		return 1; /* ldic  . */
	}
}

/* readHeader: dic  header ȯ
 */
extern struct dic_t
readHeader(FILE *fp)
{
	struct dic_t dic;

	fseek(fp, 4, SEEK_SET);

	fread(&dic, sizeof(struct dic_t), 1, fp);

	return dic;
}

/* memoryList: dic  ܾ Ʈ κ wlist ߰
 */
extern WList
*memoryList(int num, long start, long end, FILE *fp)
{
	long w_offset;
	char buf[BUFSIZ+1];
	WList *wlist;

	fseek(fp, start-1, SEEK_SET);

	while (ftell(fp) < end) {
		int pos = 0;

		fread(&w_offset, sizeof(long), 1, fp);
		
		for (;;) {
			char ch;
			ch = fgetc(fp);
			if (ch == '\0' || feof(fp))
				break;
			buf[pos] = ch;
			pos++;
		}
		buf[pos] = '\0';
		pos = 0;

		wlist = addfront(wlist, newitem(num, w_offset, buf));
	}

	return wlist;
}

/* FileSearchWord: ־ Ͽ ܾ ˻
 */
extern long
FileSearchWord(long start, long end, char *word, FILE *fp)
{
	long offset;
	int searched = 0;
	char buf[BUFSIZ+1];
	
	fseek(fp, start-1, SEEK_SET);
	while (ftell(fp) < end) {
		int pos = 0;
		
		fread(&offset, sizeof(long), 1, fp);
		
		for (;;) {
			char ch;
			ch = fgetc(fp);
			if (ch == '\0' || feof(fp))
				break;
			buf[pos] = ch;
			pos++;
		}
		buf[pos] = '\0';
		pos = 0;

		if (strcmp(word, buf) == '\0') {
			searched = 1;
			break;
		}
	}

	if (searched == 1)
		return offset;
	else
		return -1;
}

/* dbSearchMean:   offset ˻Ͽ,
 *               '\0' ϰ ȯ
 */
extern char *
dbSearchMean(long start, long pos, FILE *fp)
{
	int now = 0;
	static char mean[100000];
	
	fseek(fp, start+pos-1, SEEK_SET);
	bzero(&mean, sizeof(mean));

	for (;;) {
		char ch;

		ch = fgetc(fp);

		if (ch != '\0') {
			mean[now] = ch;
			now++;
		} else if (ch == '\0') {
			mean[now] = '\0';
			now = 0;
			break;
		}
	}

	return mean; /* ڿ */
}

/* readFnt: dic name Ʈ ˻  ȯ
 */
extern struct fnt_t
readFnt(long start, long end, char *name, FILE *fp)
{
	int pos = 0;
	char buf[BUFSIZ+1];
	char img[BUFSIZ+1];

	struct fnt_t fnt;

	fseek(fp, start-1, SEEK_SET);
	while (ftell(fp) < end) {
		char ch;

		ch = fgetc(fp);
		if (feof(fp))
			break;

		if (ch == '\0') {
			buf[pos] = '\0';
			fread(&fnt.x, sizeof(int), 1, fp);
			fread(&fnt.y, sizeof(int), 1, fp);
			fread(img, fnt.x * fnt.y, 1, fp);
			
			if (strcmp(buf, name) == '\0') {
				img[fnt.x*fnt.y] = '\0';
				fnt.img = strdup(img);
				break;
			} else {
				fnt.img = NULL;
			}
			pos = 0;
		} else {
			buf[pos] = ch;
			pos++;
		}
	}
	
	return fnt; /* struct fnt_t */
}
